/************
 * INCLUDES *
 ************/

// CORBA includes
#include <OB/CORBA.h>

// project includes
#include <GameServer_impl.h>
#include <Game_impl.h>
#include "sql_lib.h"


#ifdef HAVE_STD_IOSTREAM
using namespace std;
#endif

// ----------------------------------------------------------------------
// GameServer_impl constructor
// ----------------------------------------------------------------------

GameServer_impl::GameServer_impl(CORBA::ORB_ptr orb, 
                                 PortableServer::POA_ptr poa)
  : orb_(CORBA::ORB::_duplicate(orb)), 
  poa_(PortableServer::POA::_duplicate(poa))

{
  // Put Constructor here! 
}

// ----------------------------------------------------------------------
// GameServer_impl Destructor
// ----------------------------------------------------------------------

GameServer_impl::~GameServer_impl() {
  // Destructor here!
}

Game_ptr 
GameServer_impl::join_game(CORBA::ULong_out player_id, CORBA::ULong_out game_id)
  throw(CORBA::SystemException)
{
  // FIXME - need real values here (from database)
  player_id = 0;
  game_id   = 12;

  Game_impl* game = new Game_impl(orb_,poa_,game_id);
  PortableServer::ServantBase_var game_servant = game; 
  PortableServer::POA_var poa = _default_POA();
  poa -> activate_object(game);
  return game -> _this();
}

PortableServer::POA_ptr
GameServer_impl::_default_POA()
{
  return PortableServer::POA::_duplicate(poa_);
}




